Botan 1.10.17

Public Member Functions | List of all members
Botan::RSA_Private_Operation Class Reference

`#include <rsa.h>`

Inheritance diagram for Botan::RSA_Private_Operation:

## Public Member Functions
SecureVector< byte > | decrypt (const byte msg[], size_t msg_len)
size_t | max_input_bits () const
virtual size_t | message_part_size () const
virtual size_t | message_parts () const
| RSA_Private_Operation (const RSA_PrivateKey &rsa)
SecureVector< byte > | sign (const byte msg[], size_t msg_len, RandomNumberGenerator &rng)

## Detailed Description

RSA private (decrypt/sign) operation

Definition at line 89 of file rsa.h.

## Constructor & Destructor Documentation

## ◆ RSA_Private_Operation()

Botan::RSA_Private_Operation::RSA_Private_Operation | ( | const RSA_PrivateKey & | rsa | ) |

Definition at line 63 of file rsa.cpp.

63 :
64 n(rsa.get_n()),
65 q(rsa.get_q()),
66 c(rsa.get_c()),
67 powermod_e_n(rsa.get_e(), rsa.get_n()),
68 powermod_d1_p(rsa.get_d1(), rsa.get_p()),
69 powermod_d2_q(rsa.get_d2(), rsa.get_q()),
70 mod_p(rsa.get_p())
71 {
72 BigInt k(global_state().global_rng(), n.bits() - 1);
73 blinder = Blinder(powermod_e_n(k), inverse_mod(k, n), n);
74 }
Botan::BigInt::bits
size_t bits() const
Definition: bigint.cpp:254
Botan::Global_State_Management::global_state
Library_State & global_state()
Definition: global_state.cpp:32
Botan::inverse_mod
BigInt inverse_mod(const BigInt &n, const BigInt &mod)
Definition: numthry.cpp:314

## Member Function Documentation

## ◆ decrypt()

SecureVector< byte > Botan::RSA_Private_Operation::decrypt | ( | const byte | msg[],
|  | size_t | msg_len
| ) |  |
| virtual

Implements Botan::PK_Ops::Decryption.

Definition at line 107 of file rsa.cpp.

References Botan::Blinder::blind(), BOTAN_ASSERT, Botan::BigInt::encode(), and Botan::Blinder::unblind().

108 {
109 BigInt m(msg, msg_len);
110 BigInt x = blinder.unblind(private_op(blinder.blind(m)));
111
112 BOTAN_ASSERT(m == powermod_e_n(x),
113 "RSA private op failed consistency check");
114
115 return BigInt::encode(x);
116 }
Botan::BigInt::encode
static SecureVector< byte > encode(const BigInt &n, Base base=Binary)
Definition: big_code.cpp:64
BOTAN_ASSERT
#define BOTAN_ASSERT(expr, msg)
Definition: assert.h:19
Botan::Blinder::unblind
BigInt unblind(const BigInt &x) const
Definition: blinding.cpp:42
Botan::Blinder::blind
BigInt blind(const BigInt &x) const
Definition: blinding.cpp:29

## ◆ max_input_bits()

size_t Botan::RSA_Private_Operation::max_input_bits | ( |  | ) | const
| inline virtual

Implements Botan::PK_Ops::Decryption.

Definition at line 95 of file rsa.h.

95 { return (n.bits() - 1); }
Botan::BigInt::bits
size_t bits() const
Definition: bigint.cpp:254

## ◆ message_part_size()

virtual size_t Botan::PK_Ops::Signature::message_part_size | ( |  | ) | const
| inline virtual inherited

Find out the message part size supported by this scheme/key.

Returns
  size of the message parts

Reimplemented in Botan::ECDSA_Signature_Operation, Botan::DSA_Signature_Operation, and Botan::NR_Signature_Operation.

Definition at line 62 of file pk_ops.h.

62 { return 0; }

## ◆ message_parts()

virtual size_t Botan::PK_Ops::Signature::message_parts | ( |  | ) | const
| inline virtual inherited

Find out the number of message parts supported by this scheme.

Returns
  number of message parts

Reimplemented in Botan::ECDSA_Signature_Operation, Botan::DSA_Signature_Operation, and Botan::NR_Signature_Operation.

Definition at line 56 of file pk_ops.h.

56 { return 1; }

## ◆ sign()

SecureVector< byte > Botan::RSA_Private_Operation::sign | ( | const byte | msg[],
|  | size_t | msg_len,
|  | RandomNumberGenerator & | rng
| ) |  |
| virtual

Implements Botan::PK_Ops::Signature.

Definition at line 90 of file rsa.cpp.

References Botan::Blinder::blind(), Botan::BigInt::bytes(), Botan::BigInt::encode_1363(), and Botan::Blinder::unblind().

92 {
93 /* We don't check signatures against powermod_e_n here because
94 PK_Signer checks verification consistency for all signature
95 algorithms.
96 */
97
98 BigInt m(msg, msg_len);
99 BigInt x = blinder.unblind(private_op(blinder.blind(m)));
100 return BigInt::encode_1363(x, n.bytes());
101 }
Botan::Blinder::unblind
BigInt unblind(const BigInt &x) const
Definition: blinding.cpp:42
Botan::BigInt::bytes
size_t bytes() const
Definition: bigint.cpp:246
Botan::Blinder::blind
BigInt blind(const BigInt &x) const
Definition: blinding.cpp:29
Botan::BigInt::encode_1363
static SecureVector< byte > encode_1363(const BigInt &n, size_t bytes)
Definition: big_code.cpp:78

The documentation for this class was generated from the following files:

- src/pubkey/rsa/rsa.h
- src/pubkey/rsa/rsa.cpp